# Installment Management Service
Installment Management Service.

## Version: 1

### Servers

| URL | Description |
| --- | ----------- |
| https://cert.api.visa.com | Sandbox server |

---
## Installment Management Service API - Deprecated
Financial Institution (FI) requests Visa Installments Service (VIS) for the list of confirmed or cancelled installment transactions for a given time-period, so they can process installment conversion together with the clearing file received from payment network. Financial Institution performs cancel and refund accordingly. 

### [PUT] /installments/enrollments
**Unenrollment API**

Cardholder Unenrollment API

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| X-SERVICE-CONTEXT | header | X-SERVICE-CONTEXT | Yes | string | simple | No |

#### Request Body

List of consumer information

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"consumers"**: [ { **"settings"**: { **"availablePlans"**: [ object ], **"availableCredit"**: { **"amount"**: string, **"currencyCode"**: string }, **"installmentFrequency"**: string, **"numberOfInstallments"**: string }, **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"preTransactionInstallmentAcceptanceEnabled"**: boolean, **"postTransactionInstallmentAcceptanceEnabled"**: boolean } ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | Accepted | **application/json**: { **"201"**: object, **"UpdateConsumersResponse"**: { **"accepted"**: { **"count"**: integer }, **"rejected"**: { **"count"**: integer, **"consumers"**: [ { **"errors"**: [ { **"field"**: string, **"errorMessage"**: string } ], **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"requestIndex"**: integer } ] } } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [POST] /installments/enrollments
**Enrollments**

Installment Plan API

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"consumers"**: [ { **"settings"**: { **"availablePlans"**: [ object ], **"availableCredit"**: { **"amount"**: string, **"currencyCode"**: string }, **"installmentFrequency"**: string, **"numberOfInstallments"**: string }, **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"preTransactionInstallmentAcceptanceEnabled"**: boolean, **"postTransactionInstallmentAcceptanceEnabled"**: boolean } ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Created | **application/json**: { **"UpdateConsumersResponse"**: { **"accepted"**: { **"count"**: integer }, **"rejected"**: { **"count"**: integer, **"consumers"**: [ { **"errors"**: [ { **"field"**: string, **"errorMessage"**: string } ], **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"requestIndex"**: integer } ] } } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [GET] /installments/planAcceptances
**Get Plan Acceptance**

Plan Acceptance API

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| endDateTime | query | End Date-Time of the range for records to be returned. Date-Time should be in UTC time in ISO 8601 Format. Any timezone information provided will be ignored. | No | dateTime | form | Yes |
| page | query | Page index number of paginated records. Default = 0 (zero-based index). | No | integer | form | Yes |
| size | query | Number of records per page. Default = 20 | No | integer | form | Yes |
| startDateTime | query | Start Date-Time of the range for records to be returned. Date-Time should be in UTC time in ISO 8601 Format. Any timezone information provided will be ignored. | No | dateTime | form | Yes |
| status | query | return only planAcceptance records with this status | No | string | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"GetPlanAcceptanceDetailsResponse"**: { **"planAcceptanceDetails"**: { **"last"**: boolean, **"size"**: integer, **"sort"**: { **"empty"**: boolean, **"sorted"**: boolean, **"unsorted"**: boolean }, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"content"**: [ { **"issuerID"**: string, **"planDetails"**: { **"frequency"**: string, **"numberOfInstallments"**: integer }, **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"fixedFeeAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"purchaseAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"vtransactionID"**: string, **"acceptedDateTime"**: string, **"merchantClientID"**: string, **"transactionAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"variableFeeAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"installmentPayment"**: { **"schedule"**: [ { **"amount"**: { **"amount"**: string, **"currencyCode"**: string }, **"status"**: string, **"paymentID"**: string, **"chargeType"**: string, **"sequenceId"**: integer, **"postingDate"**: string, **"paymentDescription"**: string } ], **"totalNumberOfPayments"**: integer, **"totalNumberOfPaymentsPending"**: integer }, **"vinstallmentPlanID"**: string, **"planAcceptanceStatus"**: string, **"externalTransactionID"**: string, **"transactionDescription"**: string, **"acceptanceCancellationReason"**: string, **"vinstallmentPlanAcceptanceID"**: string, **"acceptanceCancellationDateTime"**: string } ], **"pageable"**: { **"sort"**: { **"empty"**: boolean, **"sorted"**: boolean, **"unsorted"**: boolean }, **"paged"**: boolean, **"offset"**: long, **"unpaged"**: boolean, **"pageSize"**: integer, **"pageNumber"**: integer }, **"totalPages"**: integer, **"totalElements"**: long, **"numberOfElements"**: integer } } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [POST] /installments/planAcceptances
**Get Plan Acceptance POST**

Plan Acceptance API

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| page | query | Page index number of paginated records. Default = 0 (zero-based index). | No | integer | form | Yes |
| size | query | Number of records per page. Default = 20 | No | integer | form | Yes |

#### Request Body

look-up details

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"status"**: string, **"endDateTime"**: string, **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"startDateTime"**: string, **"vInstallmentPlanAcceptanceID"**: string, **"vinstallmentPlanAcceptanceID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Created | **application/json**: { **"GetPlanAcceptanceDetailsResponse"**: { **"planAcceptanceDetails"**: { **"last"**: boolean, **"size"**: integer, **"sort"**: { **"empty"**: boolean, **"sorted"**: boolean, **"unsorted"**: boolean }, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"content"**: [ { **"issuerID"**: string, **"planDetails"**: { **"frequency"**: string, **"numberOfInstallments"**: integer }, **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"fixedFeeAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"purchaseAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"vtransactionID"**: string, **"acceptedDateTime"**: string, **"merchantClientID"**: string, **"transactionAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"variableFeeAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"installmentPayment"**: { **"schedule"**: [ { **"amount"**: { **"amount"**: string, **"currencyCode"**: string }, **"status"**: string, **"paymentID"**: string, **"chargeType"**: string, **"sequenceId"**: integer, **"postingDate"**: string, **"paymentDescription"**: string } ], **"totalNumberOfPayments"**: integer, **"totalNumberOfPaymentsPending"**: integer }, **"vinstallmentPlanID"**: string, **"planAcceptanceStatus"**: string, **"externalTransactionID"**: string, **"transactionDescription"**: string, **"acceptanceCancellationReason"**: string, **"vinstallmentPlanAcceptanceID"**: string, **"acceptanceCancellationDateTime"**: string } ], **"pageable"**: { **"sort"**: { **"empty"**: boolean, **"sorted"**: boolean, **"unsorted"**: boolean }, **"paged"**: boolean, **"offset"**: long, **"unpaged"**: boolean, **"pageSize"**: integer, **"pageNumber"**: integer }, **"totalPages"**: integer, **"totalElements"**: long, **"numberOfElements"**: integer } } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [GET] /installments/planAcceptances/{vInstallmentPlanAcceptanceID}
**Fetch Plan Acceptance**

Plan Acceptance Details [Individual] API

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| vInstallmentPlanAcceptanceID | path | A vInstallmentPlanAcceptanceID of the Accepted Installment Plan | Yes | string | simple | No |
| X-SERVICE-CONTEXT | header | X-SERVICE-CONTEXT | Yes | string | simple | No |
| externalClientID | query | Partner relationship ID | No | string | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"GetPlanAcceptanceDetailsResponse"**: { **"planAcceptanceDetails"**: { **"last"**: boolean, **"size"**: integer, **"sort"**: { **"empty"**: boolean, **"sorted"**: boolean, **"unsorted"**: boolean }, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"content"**: [ { **"issuerID"**: string, **"planDetails"**: { **"frequency"**: string, **"numberOfInstallments"**: integer }, **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"fixedFeeAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"purchaseAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"vtransactionID"**: string, **"acceptedDateTime"**: string, **"merchantClientID"**: string, **"transactionAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"variableFeeAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"installmentPayment"**: { **"schedule"**: [ { **"amount"**: { **"amount"**: string, **"currencyCode"**: string }, **"status"**: string, **"paymentID"**: string, **"chargeType"**: string, **"sequenceId"**: integer, **"postingDate"**: string, **"paymentDescription"**: string } ], **"totalNumberOfPayments"**: integer, **"totalNumberOfPaymentsPending"**: integer }, **"vinstallmentPlanID"**: string, **"planAcceptanceStatus"**: string, **"externalTransactionID"**: string, **"transactionDescription"**: string, **"acceptanceCancellationReason"**: string, **"vinstallmentPlanAcceptanceID"**: string, **"acceptanceCancellationDateTime"**: string } ], **"pageable"**: { **"sort"**: { **"empty"**: boolean, **"sorted"**: boolean, **"unsorted"**: boolean }, **"paged"**: boolean, **"offset"**: long, **"unpaged"**: boolean, **"pageSize"**: integer, **"pageNumber"**: integer }, **"totalPages"**: integer, **"totalElements"**: long, **"numberOfElements"**: integer } } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [POST] /installments/planAcceptances/{vInstallmentPlanAcceptanceID}/payments
**Early Installment Payments**

Irregular Installment Payments API

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| vInstallmentPlanAcceptanceID | path | A vInstallmentPlanAcceptanceID of the Accepted Installment Plan  | Yes | string | simple | No |

#### Request Body

Irregular Payment Information

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"numberOfPayments"**: integer, **"paymentEventType"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Created | **application/json**: { **"IrregularInstallmentPaymentsResponse"**: { **"remainingBalance"**: { **"amount"**: string, **"currencyCode"**: string }, **"nextPaymentAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"remainingPayments"**: integer, **"nextPaymentDueTimestamp"**: dateTime, **"vinstallmentPlanAcceptanceID"**: string } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [PUT] /installments/plans/consumerPreferences
**Consumer Preferences**

Set up Installments Preference API

#### Request Body

Consumer Preference Information

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"preferences"**: { **"prePurchase"**: { **"installmentPlan"**: { **"planID"**: string, **"termsAndConditions"**: { **"url"**: string, **"versionNumber"**: string } } } }, **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string } }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 200 | OK |
| 401 | Unauthorized |
| 403 | Forbidden |
| 404 | Not Found |

---
## Installment Management Service API V2
APIs used by issuers to enable Visa Installment Solutions for their customers at different points in the purchase journey, both e-commerce and in-store.

### [POST] /installments/v2/cardHolders/search
**Search Cardholder Enrollment**

Search cardholders using enrollment Profile ID or encrypted PAN

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| size | query |  | No | <br>**Default:** 1000 | Yes |
| page | query |  | No | integer | Yes |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"encAccountNumber"**: byte, **"externalClientID"**: string, **"vEnrollmentProfileID"**: string (uuid) }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Enrolled CardHolders Results page. When there are no results, any empty page is returned. The results are sorted by <code>enrollmentTimestamp</code> in reverse chronological order. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"last"**: boolean, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"totalCount"**: integer, **"totalPages"**: integer, **"resultsCount"**: integer } & { **"content"**: [ { **"productType"**: string, <br>**Available values:** "CREDIT", "DEBIT", **"encAccountNumber"**: byte, **"enrollmentStatus"**: string, <br>**Available values:** "ENROLLED", "NOT_ENROLLED", "ERROR", **"enrollmentEndDate"**: dateTime, **"enrollmentStartDate"**: dateTime, **"enrollmentTimestamp"**: dateTime, **"vEnrollmentProfileID"**: string (uuid), **"lastEnrollmentEndDate"**: dateTime, **"extendedEligibilityEndDate"**: dateTime } ] }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [GET] /installments/v2/cardHolders/batch/{vBatchID}
**Retrieve Cardholder Batch Results API**

Retrieve output of a previously submitted batch processes(Cardholder Enrollment, Cardholder Enrollment Update, Cardholder Unenrollment) using the vBatchID. There are 3 types of cardholder batch APIs:   + CARDHOLDER_ENROLLMENT   + CARDHOLDER_ENROLLMENT_UPDATE   + CARDHOLDER_ENROLLMENT_DELETE

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| vBatchID | path |  | Yes | string (uuid) | No |
| size | query |  | No | <br>**Default:** 1000 | Yes |
| page | query |  | No | integer | Yes |
| externalClientID | query |  | No | string | Yes |
| enrollmentStatus | query |  | No | string, <br>**Available values:** "ENROLLED", "NOT_ENROLLED", "ERROR" | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Get CardHolders enrollment results in this batch. All of the data submitted in the original HTTP request is echoed back in the response with errors, if any. <b>The order of the results is preserved when compared to the order of items in the original request body.</b> If there were errors creating the resource, then, an <code>errorResponse</code> is returned. + When <code>batchStatus == SUBMITTED</code> there will be no <code>content</code> & <code>batchExpirationDateTime</code> fields in the response. + When <code>batchStatus == COMPLETED</code> all fields will be available in the response. + If the batch results are not ready, a Retry-After response header may be sent, when appropriate (Default is 600 seconds). <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"last"**: boolean, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"totalCount"**: integer, **"totalPages"**: integer, **"resultsCount"**: integer } & { **"content"**: [ { **"productType"**: string, <br>**Available values:** "CREDIT", "DEBIT", **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string }, **"encAccountNumber"**: byte, **"enrollmentStatus"**: string, <br>**Available values:** "ENROLLED", "NOT_ENROLLED", "ERROR", **"enrollmentEndDate"**: dateTime, **"enrollmentStartDate"**: dateTime, **"enrollmentTimestamp"**: dateTime, **"vEnrollmentProfileID"**: string (uuid), **"lastEnrollmentEndDate"**: dateTime, **"extendedEligibilityEndDate"**: dateTime } ], **"vBatchID"**: string (uuid), **"batchType"**: string, <br>**Available values:** "CARDHOLDER_ENROLLMENT", "CARDHOLDER_ENROLLMENT_UPDATE", "CARDHOLDER_ENROLLMENT_DELETE", "PLAN_ACCEPTANCE_IRREGULAR_PAYMENTS", "CANDIDATES", **"batchStatus"**: string, <br>**Available values:** "SUBMITTED", "COMPLETED", **"batchExecutionDateTime"**: dateTime, **"batchExpirationDateTime"**: dateTime }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to   + Invoke an API request for a resource that is not part of your project.   + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used.   + The Client does not have the permissions to view the details associated with <code>batchId</code>. The value of <code>errorResponse.reason</code> is <code>forbiddenClientIDBatchIDAccess</code> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 404 | Batch not found. The batch corresponding to the vBatchID is either expired or invalid.<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [PUT] /installments/v2/accountRanges/{vAccountRangeEnrollmentID}
**Update Non-Visa Account Range Enrollment API**

This API enables Issuers to update the details of previously enrolled Non-Visa Account Range.
+ Note that this API is strictly to be used only for Non-Visa Account Range Enrollment.
+ Updating of <code>accountRangeMin</code> and/or <code>accountRangeMax</code> is not supported;
  this can be achieved by first unenrolling existing Account Range, followed by enrolling the new Account Range.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| vAccountRangeEnrollmentID | path |  | Yes | string (uuid) | No |
| externalClientID | query |  | No | string | Yes |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"accountRangeMax"**: string, **"accountRangeMin"**: string, **"vEnrollmentProfileID"**: string (uuid), **"vAccountRangeEnrollmentID"**: string (uuid) }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Account Range Enrollment updated successfully<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"accountRangeMax"**: string, **"accountRangeMin"**: string, **"vEnrollmentProfileID"**: string (uuid), **"vAccountRangeEnrollmentID"**: string (uuid) }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 404 | Account Range Enrollment is not found<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 413 | Payload Too Large<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [DELETE] /installments/v2/accountRanges/{vAccountRangeEnrollmentID}
**Unenroll Non-Visa Account Range API**

This API enables Issuers to unenroll Non-Visa Account Range
+ Note that this API is strictly to be used only for Non-Visa Account Range enrollment.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| externalClientID | query |  | No | string | Yes |
| vAccountRangeEnrollmentID | path |  | Yes | string (uuid) | No |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 204 | Account Range unenrolled successfully - No Content<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> |  |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 404 | Account Range Enrollment is not found<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 413 | Payload Too Large<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [GET] /installments/v2/consumerPreferences
**Return Captured Consumer Preferences**

This API retrieves cardholder preferences that were previously captured.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| size | query |  | No | <br>**Default:** 1000 | Yes |
| page | query |  | No | integer | Yes |
| externalClientID | query |  | No | string | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Consumer Preferences Results page. The results are sorted by <code>prePurchaseOptIn</code> in reverse chronological order. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"last"**: boolean, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"totalCount"**: integer, **"totalPages"**: integer, **"resultsCount"**: integer } & { **"content"**: [ { **"encAccountNumber"**: byte, **"prePurchaseOptIn"**: { **"vPlanID"**: string (uuid), **"optInDateTime"**: dateTime, **"acceptedTAndCVersion"**: integer } } ], <br>**Default:**  }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 404 | The referenced cardholder is not enrolled. The consumer preferences should correspond to one of the enrolled cardholders (either enrolled via encAccountNumber or enrolled via AccountRange that satisfies the passed-in PAN). <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support at developer@visa.com if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support at developer@visa.com with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support at developer@visa.com if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [POST] /installments/v2/consumerPreferences
**Capture Consumer Preference**

This API captures cardholder opt in and plan selection for pre-purchase Installments.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| v-c-idempotency-key | header | Unique ID for every API request - an optional header. Generated by the API client. Used for idempotency. | No | string (uuid) | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"encAccountNumber"**: byte, **"prePurchaseOptIn"**: { **"vPlanID"**: string (uuid), **"optInDateTime"**: dateTime, **"acceptedTAndCVersion"**: integer } } & { **"externalClientID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Consumer Preferences successfully created<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br>**v-c-idempotency-key**: Unique ID for the API response. v-c-idempotency-key is echoed back. Used for idempotency.<br> | **application/json**: { **"encAccountNumber"**: byte, **"prePurchaseOptIn"**: { **"vPlanID"**: string (uuid), **"optInDateTime"**: dateTime, **"acceptedTAndCVersion"**: integer } }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support at developer@visa.com if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support at developer@visa.com with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support at developer@visa.com if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [POST] /installments/v2/cardHolders/batch/update
**Update Cardholders Enrollment API - Batch**

Update the cardholder enrollments via an async REST API. + It can be a long-running task to update the enrollment of a lot of cardholders. + Note that this API can tolerate partial errors. So, if there are some enrollments updates that fail, the rest of the ones will be successfully updated. + If the cardholders are not already enrolled and are passed-in for update, they will NOT be enrolled as a result of this API call and there will be an error.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| v-c-idempotency-key | header | Unique ID for every API request - an optional header. Generated by the API client. Used for idempotency. | No | string (uuid) | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"cardHolders"**: [ { **"encAccountNumber"**: byte, **"enrollmentEndDate"**: dateTime, **"vEnrollmentProfileID"**: string (uuid), **"extendedEligibilityEndDate"**: dateTime } ], **"externalClientID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | CardHolders enrollment update batch job submitted successfully<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br>**v-c-idempotency-key**: Unique ID for the API response. v-c-idempotency-key is echoed back. Used for idempotency.<br> | **application/json**: { **"vBatchID"**: string (uuid), **"batchType"**: string, <br>**Available values:** "CARDHOLDER_ENROLLMENT", "CARDHOLDER_ENROLLMENT_UPDATE", "CARDHOLDER_ENROLLMENT_DELETE", "PLAN_ACCEPTANCE_IRREGULAR_PAYMENTS", "CANDIDATES", **"batchExpirationDateTime"**: dateTime }<br> |
| 400 | Any input validation of errors in <code>encAccountNumber</code> fields within the <code>cardHolders</code> array are not performed in this call. They are returned as errors in the batch results response later.  The <code>errorResponse.details</code> part of the error response may provide a list of fields which failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request. Some examples are base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br>**v-c-idempotency-key**: Unique ID for the API response. v-c-idempotency-key is echoed back. Used for idempotency.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 413 | Payload Too Large<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

#### Callback: batchCompleted

##### [POST] `{postbackNotificationUrl}`
**Postback Notifications**

These are API calls initiated by the Visa backend to the Visa Partner’s backend servers.
+ The <code>postbackNotificationUrl</code> is configured by the Visa partners during onboarding.
+ Invoked whenever the enrollments batch request results are ready for Visa partner to pull the results from Visa using another API call.
+ There will be 2 retries with random times from 1-30 minutes if there are any 5XX or 404 errors returned from the client/partner.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| x-message-tracking-id | header | Tracking ID for callback and notification sent by Visa | Yes | string | No |
| postbackNotificationUrl | path |  | Yes | string | No |
| apiKey | query |  | Yes | string | Yes |
| x-pay-token | header | See [XPayToken definition in Security Schemes](#/components/securitySchemes/x-pay-token) for details <SchemaDefinition schemaRef="#/components/securitySchemes/x-pay-token" />  | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"vBatchID"**: string (uuid), **"batchType"**: string, <br>**Available values:** "CARDHOLDER_ENROLLMENT", "CARDHOLDER_ENROLLMENT_UPDATE", "CARDHOLDER_ENROLLMENT_DELETE", "PLAN_ACCEPTANCE_IRREGULAR_PAYMENTS", "CANDIDATES", **"batchStatus"**: string, <br>**Available values:** "SUBMITTED", "COMPLETED", **"messageMetadata"**: { **"type"**: string, <br>**Available values:** "BATCH_COMPLETED", "ELIGIBILITY", "PLANACCEPTANCE_STATUS_UPDATE", "INSTALLMENT_TRANSACTION_STATUS_UPDATE", "BILATERAL_PLAN_PARTNER_STATUS_UPDATE", **"vMessageID"**: string (uuid), **"createdDateTime"**: string (date-time-nooffset) }, **"batchExecutionDateTime"**: dateTime, **"batchExpirationDateTime"**: dateTime }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 401 | Authorized error due to any of the following reasons:   + x-pay-token is not present, is blank, or is not in a valid format.   + Timestamp field not in UTC timestamp format.   + apiKey not present in request.   + apiKey is not active.   + apiKey not valid.   + apiKey not active.  |
| 403 | Forbidden |
| 500 | Internal Server Error |
| 503 | Service Unavailable |
| 2XX | Callback successfully processed; no retries will be performed. |

##### Security

| Security Schema | Scopes |
| --------------- | ------ |
| apiKey |  | x-pay-token |  |

### [GET] /installments/v2/accountRanges
**Retrieve Non-Visa Account Range Enrollment API**

This API enables Issuers to retrieve details of Non-Visa Account Range Enrollments.
+ Note that this API is strictly to be used only for Non-Visa Account Range Enrollment.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| size | query |  | No | integer, <br>**Default:** 100 | Yes |
| page | query |  | No | integer | Yes |
| externalClientID | query |  | No | string | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | A list of Account Range Enrollments<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"last"**: boolean, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"totalCount"**: integer, **"totalPages"**: integer, **"resultsCount"**: integer } & { **"content"**: [ { **"accountRangeMax"**: string, **"accountRangeMin"**: string, **"vEnrollmentProfileID"**: string (uuid), **"vAccountRangeEnrollmentID"**: string (uuid) } ], <br>**Default:**  }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 404 | Account Range Enrollment is not found<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 413 | Payload Too Large<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [POST] /installments/v2/accountRanges
**Enroll Non-Visa Account Range API**

This API enables Issuers to enroll Non-Visa Account Range and associate it to Enrollment Profile.
+ Note that this API is strictly to be used only for Non-Visa Account Range Enrollment.
+ The first 6 characters of <code>accountRangeMin</code> and <code>accountRangeMax</code> have to be equal.
+ If <code>accountRangeMin</code> or <code>accountRangeMax</code> being enrolled is less than 16 characters,
  it will be automatically padded by the system.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| externalClientID | query |  | No | string | Yes |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"accountRangeMax"**: string, **"accountRangeMin"**: string, **"vEnrollmentProfileID"**: string (uuid) }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Account Range Enrollment created successfully<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"accountRangeMax"**: string, **"accountRangeMin"**: string, **"vEnrollmentProfileID"**: string (uuid), **"vAccountRangeEnrollmentID"**: string (uuid) }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
[...]
